/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 *  File Name	: megaide_kernel_lib.h
 */

#ifndef __MEGAIDE_KERNEL_LIB_H__
#define __MEGAIDE_KERNEL_LIB_H__

extern VOID ScsiPortStallExecution(UINT);
extern UCHAR ScsiPortReadPortUchar(ULONG);
extern USHORT ScsiPortReadPortUshort(ULONG);
extern VOID ScsiPortReadPortBufferUshort(ULONG, VOID *, UINT);
extern VOID ScsiPortWritePortUchar(ULONG, UCHAR);
extern VOID ScsiPortWritePortBufferUshort(ULONG, const VOID *, UINT);
extern VOID ScsiPortWritePortUlong(ULONG, UINT);
extern UINT ScsiPortReadRegisterUlong(ULONG);
extern VOID ScsiPortWriteRegisterUlong(ULONG, UINT);
extern UINT ScsiPortReadRegisterUchar(ULONG);
extern VOID ScsiPortWriteRegisterUchar(ULONG, UINT);


extern asmlinkage 
	int printk_Rlsi(const CHAR * fmt, ...);

extern INT memcmp_Rlsi(const VOID *, const VOID *, size_t);
extern VOID * memcpy_Rlsi(VOID *, const VOID *, size_t);
extern VOID * memmove_Rlsi(VOID *, const VOID *, size_t);
extern VOID * memset_Rlsi(VOID *, INT, size_t);
extern CHAR * strncpy_Rlsi(CHAR *, const CHAR *, size_t);
extern INT strncmp_Rlsi(const CHAR *, const CHAR *, size_t);
extern INT pci_read_config_word_Rlsi(HW_DEVICE_EXTENSION *, INT, USHORT *);
extern INT pci_read_config_byte_Rlsi(HW_DEVICE_EXTENSION *, INT, UCHAR *);
extern INT pci_write_config_word_Rlsi(HW_DEVICE_EXTENSION *, INT, USHORT);
extern INT pci_write_config_byte_Rlsi(HW_DEVICE_EXTENSION *, INT, UCHAR);
extern VOID wake_up_Rlsi(HW_DEVICE_EXTENSION *);
extern VOID sleep_on_timeout_Rlsi(HW_DEVICE_EXTENSION *);
extern USHORT pci_map_sg_Rlsi(HW_DEVICE_EXTENSION *, FAST_IDE_SCB_EXTENSION *);
extern VOID pci_unmap_sg_Rlsi(HW_DEVICE_EXTENSION *, FAST_IDE_SCB_EXTENSION *);
extern ULONG pci_map_single_Rlsi(HW_DEVICE_EXTENSION *pdev, VOID *buff , UINT len);

extern VOID pci_unmap_single_Rlsi(HW_DEVICE_EXTENSION *, VOID *, UINT);
extern VOID *request_region_Rlsi(USHORT, UINT);
extern VOID release_region_Rlsi(USHORT, UINT);
extern UINT CURRENT_TIME_RLSI(VOID);
UINT get_jiffies_count(VOID);
UINT mega_get_hz_value(VOID);
VOID *kmalloc_Rlsi(INT size);
VOID kfree_Rlsi(VOID *objp);

#endif /* __MEGAIDE_KERNEL_LIB_H__ */

/* vim: set ts=8 sw=8 tw=78 ai si: */
