/*
 * Linux MegaRAID IDEal Software RAID Stack
 * Copyright (c) 2001 LSI Logic Corporation, All Rights Reserved.
 *-----------------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *-----------------------------------------------------------------------------
 *  File Name	: megaide_pci.h
 */

#ifndef __MEGAIDE_PCI_H__
#define __MEGAIDE_PCI_H__

INT mide_find_card(Scsi_Host_Template * pstHostTmp,USHORT sPciVendor,
		USHORT sPciDev, INT lFlag);
BOOLEAN mide_check_for_supported_device(struct pci_dev *pstDev,
		USHORT sPciDev, USHORT sSubsysId, 
		USHORT sSubsysVId, INT lFlag);
BOOLEAN mide_allocate_device_ext_mem (HW_DEVICE_EXTENSION *pdev,
		struct pci_dev *pstDev, USHORT sNumFound);
VOID mide_init_cardtype_and_speed (HW_DEVICE_EXTENSION *pdev, USHORT deviceID);
BOOLEAN mide_init_base_address (HW_DEVICE_EXTENSION *pdev, 
		struct pci_dev *pstDev);
VOID initialize_device_extension(HW_DEVICE_EXTENSION *pdev);
INT mide_get_option_rom_info(HW_DEVICE_EXTENSION *pdev);
VOID mega_set_switch_drive_on_chan(HW_DEVICE_EXTENSION *pdev, UCHAR chan);
INT HyperDiskScanForDevices(HW_DEVICE_EXTENSION *pdev);
BOOLEAN FindDevices(HW_DEVICE_EXTENSION *pdev, UCHAR Channel);
BOOLEAN GetIoMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
BOOLEAN GetTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
BOOLEAN SetTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId,
		MP_TRANSFER_MODE TransferMode);
BOOLEAN AssignSglPtrsForChannels(HW_DEVICE_EXTENSION *pdev);
VOID RemoveBuildInIDESupport(struct pci_device_id *id);
BOOLEAN ClaimOurIOPorts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN ReleaseOurIOPorts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN IsDrivePresent(HW_DEVICE_EXTENSION *pdev, UCHAR tid);
BOOLEAN IssueIdentify(HW_DEVICE_EXTENSION *pdev, UCHAR DeviceNumber,
		UCHAR Channel, UCHAR Command);
BOOLEAN InitDriveFeatures(HW_DEVICE_EXTENSION *pdev);
BOOLEAN mega_set_rw_cache_mode(HW_DEVICE_EXTENSION *pdev, UCHAR ucDrvInd);
BOOLEAN set_multi_block_xfers(HW_DEVICE_EXTENSION *pdev, UCHAR tid);
VOID SetDriveParameters(HW_DEVICE_EXTENSION *pdev);
VOID SetDriveParams(HW_DEVICE_EXTENSION *pdev,  UCHAR DeviceNumber);
VOID CleanUpAdapter(HW_DEVICE_EXTENSION *pdev);
BOOLEAN PostCommandToDrive(HW_DEVICE_EXTENSION *pdev, UINT uiTargetId,
		UINT uiStartBlock, UINT uiBlockCount,
		UCHAR ucCmd, ULONG ulSglPhysicalAddress);
HW_DEVICE_EXTENSION *GetDeviceExtension(UCHAR ucIndex);

INT mide_array_to_int(const CHAR * pcArray);

/* Generic Functions */
BOOLEAN FoundInterrupt(HW_DEVICE_EXTENSION *pdev, UCHAR *pucChannel);
BOOLEAN EnableInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN Is80PinCable(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannelId);

VOID ICH5R_reset_all_channels(HW_DEVICE_EXTENSION *pdev);
VOID mega_ICH5R_poll_thread(HW_DEVICE_EXTENSION *pdev);
VOID mega_start_ICHxR_poll_thread(HW_DEVICE_EXTENSION *pdev);
VOID mega_kill_ICHxR_poll_thread(HW_DEVICE_EXTENSION *pdev);

VOID mega_ICH6R_poll_thread(HW_DEVICE_EXTENSION *pdev);
VOID mega_ICH7R_poll_thread(HW_DEVICE_EXTENSION *pdev);

BOOLEAN mide_init_adp_info_and_pointers(HW_DEVICE_EXTENSION *pdev, USHORT usTid);

/*athena chipset Related Functions */
BOOLEAN EnableAthenaInterrupts(HW_DEVICE_EXTENSION *pdev);
BOOLEAN DisableAthenaInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN mide_handle_athena_pm_hp(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaEnablePMInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaEnableHPInterrupt(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaDisablePMInterrupts(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaDisableHPInterrupt(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaInitializePMRegisters(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN AthenaMoveInterfaceToActiveMode(HW_DEVICE_EXTENSION *pdev,
		UCHAR ucDriveId);
extern UCHAR AthenaDetectPhysicalChange(HW_DEVICE_EXTENSION *pdev,UCHAR chan);

/*externs in the megaide_lib.o*/
extern BOOLEAN IsPostCommandToDriveSuccess(HW_DEVICE_EXTENSION *pdev,
		UINT uiTargetId, UINT uiStartBlock, UINT uiBlockCount,
		UCHAR ucCmd, ULONG ulSglPhysicalAddress);
extern VOID FlushCache(HW_DEVICE_EXTENSION *pdev);
extern size_t get_gatekeeper_size(VOID);
extern size_t get_scb_extension_size(VOID);
extern size_t get_physcial_drive_command_size(VOID);
extern BOOLEAN IssuePowerOnResetToDrives(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN StopBusMasterTransfers(HW_DEVICE_EXTENSION *pdev);
extern VOID AtapiHwInitialize(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN GetConfigInfoAndErrorLogSectorInfo(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN ConfigureRaidDrives(HW_DEVICE_EXTENSION *pdev, UCHAR *pBuffer);
extern BOOLEAN EnquireProperties(HW_DEVICE_EXTENSION *pdev, BOOLEAN blBootTime);
extern VOID megaide_kill_backgroundtask_and_wait(HW_DEVICE_EXTENSION *pdev);
extern VOID ClearPCIInterupt(HW_DEVICE_EXTENSION *pdev, UCHAR ucChannel);
extern VOID check_for_config_update(HW_DEVICE_EXTENSION *pdev);
extern BOOLEAN megaide_atapi_startio(HW_DEVICE_EXTENSION *pdev,
		FAST_IDE_SCB_EXTENSION *scb);
extern UCHAR HandleIOCTLCall(HW_DEVICE_EXTENSION *pdev,
		FAST_IDE_SCB_EXTENSION *scb);
extern VOID megaide_abort_ioctl(HW_DEVICE_EXTENSION *pdev,
		FAST_IDE_SCB_EXTENSION *scb);
extern BOOLEAN FastIDEResetBus(HW_DEVICE_EXTENSION *pdev);
extern INT FastIDEInterrupt(HW_DEVICE_EXTENSION *pdev);
extern LOGICAL_DRIVE_INFO *GetLDInfo(HW_DEVICE_EXTENSION *pdev,
		UCHAR  chan, UCHAR tid, UCHAR Lun);
extern BOOLEAN SetMaxTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
extern UCHAR GetInquiryTransferMode(HW_DEVICE_EXTENSION *pdev, UCHAR TargetId);
extern UINT mega_discover_bp(HW_DEVICE_EXTENSION *pdev);
#endif /*__MEGAIDE_INIT_H__*/
/* vim: set ts=8 sw=8 tw=78 ai si: */
